xquery version "3.1";

declare namespace tei="http://www.tei-c.org/ns/1.0";

declare variable $local:XML :=
    <body>
        <p>The proposed NSSD will prepare us to establish U.S. policy, the U.S. negotiating position, and U.S. strategies for START, and will provide a <add>foundation</add> to guide the conduct of the U.S. as negotiations progress<note>Reagan indicated his approval by writing a checkmark and his initials. The NSDD is printed as Document 6.</note>. The establishment of the NSSD will assure comprehensiveness and <unclear>timeliness</unclear> of the interagency work. The NSSD sets a date for completion of the study by May 1, 1982. This will assure necessary momentum and timely preparation of options and recommendations for consideration by the National Security Council. Resulting decisions will be formalized in a National Security Decision Directive (NSDD).</p>
    </body>;

declare function local:process($nodes as node()*, $startNode as text(), $startOffset as xs:int, 
    $endNode as text(), $endOffset as xs:int) {
    for $node in $nodes
    return
        typeswitch ($node)
            case element() return
                element { node-name($node) } {
                    $node/@*,
                    local:process($node/node(), $startNode, $startOffset, $endNode, $endOffset)
                }
            case text() return
                if ($node is $startNode) then (
                    text { substring($node, 1, $startOffset - 1) },
                    <match>
                    {
                        text { substring($node, $startOffset) },
                        $node/following::node()[. << $endNode]
                    }
                    </match>
                ) else if ($node is $endNode) then
                    ()
                else
                    $node
            default return
                $node
};

let $startNode := $local:XML/p/text()[1]
let $startOffset := 48
let $endNode := $local:XML/p/add/text()
let $endOffset := 10
return
    local:process($local:XML, $startNode, $startOffset, $endNode, $endOffset)